<template>
    <AppDashboard />
    <div class="sm:ml-64">
        <h1 class="flex items-center text-5xl font-extrabold dark:text-white">craftforms<span class="bg-orange-100 text-orange-800 text-2xl font-semibold me-2 px-2.5 py-0.5 rounded-lg dark:bg-orange-200 dark:text-orange-800 ms-2">lite</span></h1>

        <div class="mockup-code mt-10">
            <pre data-prefix="$"><code>{{ lines[0].value }}</code></pre>
            <pre data-prefix=">" class="text-warning"><code>{{ lines[1].value }}</code></pre>
            <pre data-prefix=">" class="text-success"><code>{{ lines[2].value }}</code></pre>
        </div>
        <div class="container mx-auto p-4">
            <h1 class="text-2xl font-bold mb-4">Formulaires disponibles</h1>
            <div class="grid grid-cols-1 md:grid-cols-2 lg:grid-cols-3 gap-4">
                <div v-for="form in forms" :key="form.name" class="card shadow-lg">
                    <figure class="px-10 pt-10">
                    <!-- <img src="/path/to/your/image.png" alt="Image" class="rounded-xl"> -->
                    </figure>
                    <div class="card-body items-center text-center">
                        <h2 class="card-title">{{ form.name }}</h2>
                        <p>{{ form.desc }}</p>
                        <div class="card-actions">
                            <NuxtLink :to="form.id" class="btn btn-primary">Ouvrir</NuxtLink>
                        </div>
                    </div>
                </div>
            </div>
        </div>

    </div>
</template>


<script setup>
    import { ref, onMounted } from 'vue'

    const texts = [
        'craft document',
        'crafting document...',
        'crafting done!',
    ]

    const lines = [
        ref(''), 
        ref(''), 
        ref(''),
    ]

    const clearLines = () => {
        lines.forEach(line => line.value = '')
    }

    clearLines()

    const typingEffect = (element, text, delay, callback) => {
        let i = 0
        const interval = setInterval(() => {
        element.value += text.charAt(i)
        i++
        if (i === text.length) {
            clearInterval(interval)
            if (callback) callback()
        }
        }, delay)
    }

    const startTypingEffect = () => {
        clearLines()

        const animateLine = (index) => {
            if (index < lines.length) {
            typingEffect(lines[index], texts[index], 150, () => {
                animateLine(index + 1)
            })
            } else {
            // Delay before restarting the animation
            setTimeout(() => {
                startTypingEffect()
            }, 4000)  // Adjust the delay as needed
            }
        }

        animateLine(0)
        }


    onMounted(() => {
        startTypingEffect()
    })

    const forms = ref([])

    onMounted(async () => {
        const response = await fetch('/api/PrintCraftforms') // Corrected API endpoint
        forms.value = await response.json()
    })
</script>
